/* 'for' short form */
#define F(v,h)for(v=0;v<h;v++)
/* launch instruction 'i' for every tile in the dungeon */
#define D(i)F(y,S)F(x,T){i;}
/* short form for dungeon tile at position x,y */
#define G d[x][y]
/* short form for dungeon tile at position x+f,y+g - useful for movement/generation */
#define M d[x+f][y+g]
/* sign of number 'n' */
#define Z(n)n<0?-1:n?1:0
/* item handling helper */
#define C(v,i)M^v||(i,M=e),
/* random number */
#define r rand()

/*
	Variables:
	x,y - always indicate a position in the dungeon, used mostly through G
	c   - helper variable, stores pressed character, used for color pairs initialization
	L   - current dungeon level
	l,p - HP current/maximum
	v   - gold collected
	f,g - secondary dungeon position, used in generation/movement
	b   - temporary variable
	d[][] - dungeon map
	
	Constants:
	S,T - size of dungeon, SxT
	e   - a constant meaning '.'
	u   - a constant used for monster handling, 'a'-1.
	k[] - a table used for coloring output, putting stuff in the dungeon, and doing chests
*/
int x,y,S=23,T=62,c,L,b,k[]=L"$`*$.@`>$]```",
	f,g,l=18,p=18,w=1,e=46,v,u=96,K=256,d[90][90],z[90][90];
	
/* move the actor at (x,y) by [f,g] */
m(f,g){
	/* is player? */
	G-64?
		/* not a player, so a monster */	
		/* monster moved into player? */
		M-64||(l-=G-u)>0||(M=e)
	:
	(
		/* player code */
		/* stairs */
		M^T||N(),
		/* talismans */
		C(u,p+=L)
		/* power gems */
		C(42,l=p)
		/* gold */
		C(36,v+=x%9*L+L)
		/* weapons */
		/*C(47,(w=L+r%4-2)<1&&(w=1))*/
		C(93,w=(c=L+r%4)<3?1:c-2)
		/* attacking monsters */
		M>u&&(M-=r%w+1)%K<=u&&(M=k[r%5+8])
	)	
	;
	
	/* actual movement */
	M-e?M-35||(g&&m(f,0),f&&m(0,g)):(M=G|K,G=e);
}
/* find a random empty position and insert t in it */
E(t){while(x=r%T,y=r%S,G-e);G=t;}

N(){
	L++;
	/* fill with walls */
	D(G=35)
	/* add rooms */	
	x=y=9;
	F(b,S)
	{
		f=r%58+1;g=r%21+1;
		while(f^x||g^y)
			G=e,
			r&1?(x+=Z(f-x)):(y+=Z(g-y));
	}
	f=0;
	/* put objects from 'k' into dungeon */
	F(b,9)L<9&&E(k[b]);
	/* put monsters */
	F(b,L*2)E(99+r%(L*7/5));
}

/* main */
main()
{
	/* curses/srand initialization */
	srand(initscr());raw();start_color();
	
	/* set up colors */
	F(c,8)init_pair(c+1,c,0);
	
	/* generate a level */
	N();
	
	/* play until Q is pressed */
	while(c-81)
	{
		/* find player, store position in f,g */
		D(G-64||(f=x,g=y))
		
		/* draw screen */
		D(
			/* determine tile colour */
			b=1;while(G^k[b++]&&b<8);
			/* check for visibility */
			F(c,u)d[f+(x-f)*c/u][g+(y-g)*c/u]-35||(b=z[x][y]<L?1:5);
			/* memory */
			b>6&&G<64&&(z[x][y]=L);
			/* draw */
			mvaddch(y,x,G|b*K)
		)
		
		/* status bar */
		mvprintw(S,0,"H:%d/%d W:d%d L:%d $%d %s",l,p,w,L,v,L^9?"":"WIN");
		
		/* get input */
		c=mvgetch(0,0);
				
		/* move monsters */
		D(G>u&&G<K&&m(Z(f-x),Z(g-y)))				

		/* move player, if needed */
		D(G-64||m((c-1)%3-1,Z(2+(e-c)/3)))
		
		/* clear move flags for player and monsters */
		D(G&=255)
	}
	
	/* clean up */
	endwin();
}
